Đến nội dung


Hình ảnh
- - - - -

[Yêu cầu ] Lisp Xoay Viewport tùy ý


  • Please log in to reply
34 replies to this topic

#1 NTD

NTD

    biết lệnh rotate

  • Members
  • PipPipPip
  • 135 Bài viết
Điểm đánh giá: 11 (tàm tạm)

Đã gửi 12 July 2012 - 03:06 AM

Em là Kiến Trúc Sư , em vẽ Mặt Bằng nhà xong thì muốn vẽ tiếp Mặt Bên + Măt Cắt Ngang của nhà ( các hinh chiếu có hướng chiếu so với Măt Bằng là đi từ bên trái hay bên phải nhìn vào ,các bác đừng nhầm lẫn khái niệm với Mặt Đứng & Mặt Cắt Dọc nhé , 2 cái đấy em ko có vấn đề gì) thì em có 2 cách : Làm hết bên Model Space nha , ko muốn chơi Paper Space đâu
Cách 1 : copy cả đống Mặt Bằng của các tầng ra xoay 90 độ hay -90 độ để bắt đầu vẽ Mặt Bên + Măt Cắt Ngang , trong quá trình vẽ mà phát hiện MBằng có thiếu sót gì thì sửa cái MBằng đã xoay đó rối lại up lại vô cái MBằng chưa xoay ==> hơi mất công . MBằng mà trước khi xoay nếu Block lại thì ra vào Block thường xuyên ==> regen bản vẽ , ===> sốt ruột . MBằng mà trước khi xoay nếu Group lại thì muốn edit sẽ Ctrrl+Shift+A liên tục và rồi vẫn phải up lại vô cái MB chưa xoay ==> vẫn là mất công
Gét nhất cách làm này là làm tăng đôi số MBằng ==> nặng bản vẽ nếu là dự án lớn . Tóm lại ko muốn làm cách này nữa , các bác đừng cố viết Lisp theo hướng này
Cách 2 : xoay UCS 90 độ hay -90 độ , gọi lệnh Plan , Enter luôn nó sẽ tự chọn cái UCS hiện thời rồi để xoay view rồi tự động.... zoom Extents bản vẽ ===> có thể tự động regen bản vẽ nếu bộ nhớ tràn hay zoom lúc trước quá nhỏ so với zoom Extents ( CAD dở hơi , đáng gét ) rồi lại mất công lăn chuột pan zoom đến chỗ phần bản vẽ đang sử lý ( mất công vì ko thể zoom Previous đc ) Cách làm này ko tăng đôi MBằng , nhẹ bản vẽ , ko mất công up vì chỉ có 1 MBằng , thông tin hình họa luôn có thể so sánh đối chiếu & chỉnh sửa nhanh , nhưng nếu hay muốn về View với Plan của UCS quốc tế để thao tác với Mặt Đứng Dọc & Măt Đứng Chính thì xoay UCS liên tục rồi Plan ===> hay zoom Extents & regen bản vẽ . Bực lắm rồi

Em muốn các bác viết 1 Lisp hỗ trợ em làm theo cách 2 sao cho khi em gọi lệnh để xoay view Lisp sẽ ko tự động zoom Extents mà sẽ cho em chọn 1 điểm làm tâm xoay cho chọn hướng xoay bất kỳ( Bằng cách dùng chuột , nên ưu tiên cách này & bằng cách nhập từ bàn phím góc xoay ) và điểm xoay đó sẽ là tâm điểm của Viweport tĩnh sau khi kết thúc lệnh và nhất là zoom Scale ko thay đổi so với viewport trước + UCS cũng thay đổi sao cho XY tương ứng với View cuối cùng ko bị xoay chéo đi thì tốt quá . Đăc biệt các bác ko cho nó tự động regen bản vẽ trong bất kỳ trường hợp nào hộ em nha . Nếu đc thì Lisp nên có thêm chế độ Object để lúc bảo chọn tâm xoay thi enter 1 phát sẽ ra chế độ chọn đối tượng để zoom Object sau khi đã xoay view bằng cách chỉ hướng hay gõ góc xoay, Và cả chế độ Window để chọn của sổ và xoay view với tâm Window đó sau khi chỉ hướng hay gõ góc xoay ( tất nhiên 2 chế độ này sẽ làm Zoom Scale thay đổi ) . 2 chế độ thêm vô này như là của lệnh zoom đó
Mời các bác xuống núi . Em xin cảm ơn tất cả ý kiến & Lisp các bác viết cho
  • 0

#2 ketxu

ketxu

    Copier - Paster - Editor

  • Moderator
  • PipPipPipPipPipPipPip
  • 5679 Bài viết
Điểm đánh giá: 2605 (tuyệt vời)

Đã gửi 12 July 2012 - 08:36 AM

@NTD : đọc xong 2 topic của bạn thấy mình ngu luôn. Chỉ e có những thứ bạn tự làm bạn mất kiếm soát khi vẽ - phức tạp hóa khi vẽ

- Topic 1 : dùng reactor vô cùng đơn giản, sẽ copy được hết như bạn mong muốn, nhưng không thể view động được khi bạn đang vẽ (với lisp). Ucs ảo thì chỉ cần chọn o và chọn hướng X là được, mình k nghĩ bạn vẽ mặt bằng thì cần oxy bị lộn ngược lại (?)

- Topic 2 : viewport bên Model Space ?
Mà bạn vẽ chi khi mà cái mặt bằng chưa hòm hòm đã đi bổ rồi (để mà thực hiện cái thao tác xoay kia liên tục ?)
Hoặc cùng lắm cho tất cả các đối tượng bao gồm mặt bằng - mặt đứng - mặt bên vào 1 group, lúc cần thì xoay cả cụm, đảm bảo theo ý bạn

P/s : cả 2 cái này người viết lisp đều làm được, bạn mới chỉ sấn được tới phần ssget đã bỏ của chạy theo selectsimilar (cad đời cũ thì có ssx), sao không cố lên 1 chút nữa bạn ?
  • 1

Thành viên nhóm CadMagic.
Mời bạn ghé thăm facebook nhóm - Page viết lisp theo yêu cầu  :
CAD MAGIC


#3 Thaistreetz

Thaistreetz

    biết lệnh adcenter

  • Advance Member
  • PipPipPipPipPipPipPip
  • 903 Bài viết
Điểm đánh giá: 505 (tốt)

Đã gửi 12 July 2012 - 09:10 AM

Ketxu nói đúng suy nghĩ của mình luôn!
@NTD. hix. mới sáng ra, đầu óc còn tỉnh táo mà vào đọc 2 topic bạn lập thấy lú luôn. Trình bày ngắn gọn, đủ ý để hiểu thôi, đừng lan man như vậy. nếu khó diễn đạt câu chữ thì bạn có thể minh họa bằng hình ảnh hoặc file bản vẽ.
  • 0

Hình đã gửi
IN HIM, I TRUST. THE TRUST IN MY GOD


#4 trinhvqh

trinhvqh

    biết lệnh block

  • Members
  • PipPipPipPipPipPip
  • 408 Bài viết
Điểm đánh giá: 222 (khá)

Đã gửi 12 July 2012 - 09:11 AM

Em là Kiến Trúc Sư , em vẽ Mặt Bằng nhà xong thì muốn vẽ tiếp Mặt Bên + Măt Cắt Ngang của nhà ( các hinh chiếu có hướng chiếu so với Măt Bằng là đi từ bên trái hay bên phải nhìn vào ,các bác đừng nhầm lẫn khái niệm với Mặt Đứng & Mặt Cắt Dọc nhé , 2 cái đấy em ko có vấn đề gì) thì em có 2 cách : Làm hết bên Model Space nha , ko muốn chơi Paper Space đâu
Cách 1 : copy cả đống Mặt Bằng của các tầng ra xoay 90 độ hay -90 độ để bắt đầu vẽ Mặt Bên + Măt Cắt Ngang , trong quá trình vẽ mà phát hiện MBằng có thiếu sót gì thì sửa cái MBằng đã xoay đó rối lại up lại vô cái MBằng chưa xoay ==> hơi mất công . MBằng mà trước khi xoay nếu Block lại thì ra vào Block thường xuyên ==> regen bản vẽ , ===> sốt ruột . MBằng mà trước khi xoay nếu Group lại thì muốn edit sẽ Ctrrl+Shift+A liên tục và rồi vẫn phải up lại vô cái MB chưa xoay ==> vẫn là mất công
Gét nhất cách làm này là làm tăng đôi số MBằng ==> nặng bản vẽ nếu là dự án lớn . Tóm lại ko muốn làm cách này nữa , các bác đừng cố viết Lisp theo hướng này
Cách 2 : xoay UCS 90 độ hay -90 độ , gọi lệnh Plan , Enter luôn nó sẽ tự chọn cái UCS hiện thời rồi để xoay view rồi tự động.... zoom Extents bản vẽ ===> có thể tự động regen bản vẽ nếu bộ nhớ tràn hay zoom lúc trước quá nhỏ so với zoom Extents ( CAD dở hơi , đáng gét ) rồi lại mất công lăn chuột pan zoom đến chỗ phần bản vẽ đang sử lý ( mất công vì ko thể zoom Previous đc ) Cách làm này ko tăng đôi MBằng , nhẹ bản vẽ , ko mất công up vì chỉ có 1 MBằng , thông tin hình họa luôn có thể so sánh đối chiếu & chỉnh sửa nhanh , nhưng nếu hay muốn về View với Plan của UCS quốc tế để thao tác với Mặt Đứng Dọc & Măt Đứng Chính thì xoay UCS liên tục rồi Plan ===> hay zoom Extents & regen bản vẽ . Bực lắm rồi


Rõ ràng cách 2 đỡ mất công hơn cách 1.
Tôi thấy với các phiên bản cad đời sau (2012,2013) việc xoay UCS khá dễ dàng nên chả cần lisp

Thành thật mà nói thì cả 2 cách đều không hay
Việc tư duy và vẽ 2D khó có thể kiểm soát hết các chi tiết
Cho nên tốt nhất là dựng 3D rồi xuất về 2D.
Mọi thay đổi đều từ mô hình 3D và 2D cứ thế cập nhật

Cuối cùng nói vui thôi "ở Việt Nam có 80 triệu dân thì có 80tr kts rồi trừ mấy thằng thợ vẽ như mình"
  • 0

#5 duy782006

duy782006

    PHẠM QUỐC DUY

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 2155 Bài viết
Điểm đánh giá: 1360 (rất tốt)

Đã gửi 12 July 2012 - 09:27 AM

Đúng là với cả lô sích sông ý tưởng như vậy bạn TND nên theo hướng của bác Trinh ấy là cuyển qua học quả "aka" như bác ấy đi!
  • 0

Cứ ngỡ trần gian là cõi thật.Cho nên tất bật đến bây giờ.
Tạo hộp thoại bằng lisp My blog QUY ĐỊNH ĐẶT TÊN TOPIC TRONG CHUYÊN MỤC LISPD http://ktsduy.wordpress.com/
Để cám ơn chỉ cần nhấn rep_up.png
(Là nhấn vào nút đó phía bài viết của người ta í chứ đừng có nhè cái hình này mà nhấn miết đi nha :-D


#6 trinhvqh

trinhvqh

    biết lệnh block

  • Members
  • PipPipPipPipPipPip
  • 408 Bài viết
Điểm đánh giá: 222 (khá)

Đã gửi 12 July 2012 - 10:00 AM

Đúng là với cả lô sích sông ý tưởng như vậy bạn TND nên theo hướng của bác Trinh ấy là cuyển qua học quả "aka" như bác ấy đi!


Có nhiều cách chứ không nhất thiết phải là aka mới được bác Duy ạ!
Dù cách gì thì cũng đi từ 3D ->2D chứ không phải loay hoay với các MB,MD,MC trừ trường hợp chỉnh sửa lại các bản vẽ có sẵn cho phù hợp với thực tế thi công
  • 1

#7 NTD

NTD

    biết lệnh rotate

  • Members
  • PipPipPip
  • 135 Bài viết
Điểm đánh giá: 11 (tàm tạm)

Đã gửi 12 July 2012 - 10:20 AM

- Thôi em ko dám trình bày dài nữa . Nói ngắn là xin các bác 1 cái Lisp về lệnh PLan kiểu mới sao cho nó ko có những khuyết điểm như Plan cũ và có thêm những lựa chọn mới mà em đã ...viết ở Post 1 .
- Trình độ viêt Lisp của em còn gà lắp, mói chỉ dùng ở việc chế Lisp kiểu lắp gép thôi, đầu óc lại chậm tiêu nên dù đã cố gắng em vẫn chưa thực hiên đc rất nhiều idea mình ấp ủ . Mong các bác viết cho để trước mắt đưa vô công việc thực tế sau là có lưng vốn kiến thức về Lisp để mà nâng cao trình lên . ssget bác ketxu dạy em đẫ đưa vô 1 loạt Lips chuyên chỉ chọn đối tượng dùng trong công việc tiện lắm . selectsimilar thì em đã biết sau đó thấy nó có cai hay hơn ssget là chỉ cần nhớ 1 lệnh nên đương nhiên là em dùng nó thường xuyên
- Em ko vẽ 3D xuất ra 2D đâu , làm hồ sơ kỹ thuật thi công ko ai làm thế cả vì vẽ 3D Max & Sketup phải vẽ quạ cho nhanh chứ. Có vẽ 3D chuẩn sau này CAD 2D lên vần còn chỉnh chán vì yếu tố kỹ thuật cơ mà . Em cũng mầy mò revit & ADT nhưng hiện h đang đơn độc tại cty toàn dùng CAD , ko biết bao h mới đưa vô dùng cho 1 dự án thực tế
- Em phát hiện ra 1 điều thú vị là các bác trên này hay bị dị ứng với từ Kiến Trúc Sư , thôi em đã dùng từ đó lần cuối cùng :D
  • 0

#8 NTD

NTD

    biết lệnh rotate

  • Members
  • PipPipPip
  • 135 Bài viết
Điểm đánh giá: 11 (tàm tạm)

Đã gửi 12 July 2012 - 10:42 AM

Hôm trước em ra phố Nguyễn Xí tìm sách dạy AutoLisp mà đi tìm cả nửa ngày chẳng có quyển nào , đến là chán , EL thì dốt Help đọc ko hiểu . Bác nào có tài liệu tiếng việt dạy kiểu nói rõ ràng cụ thể như bác ketxu làm 1 tut về ssget bên topic kia thì share cho em với , em cảm ơn nhiều lắm
  • 0

#9 NTD

NTD

    biết lệnh rotate

  • Members
  • PipPipPip
  • 135 Bài viết
Điểm đánh giá: 11 (tàm tạm)

Đã gửi 12 July 2012 - 11:22 AM

@NTD : đọc xong 2 topic của bạn thấy mình ngu luôn. Chỉ e có những thứ bạn tự làm bạn mất kiếm soát khi vẽ - phức tạp hóa khi vẽ

- Topic 1 : dùng reactor vô cùng đơn giản, sẽ copy được hết như bạn mong muốn, nhưng không thể view động được khi bạn đang vẽ (với lisp).Em chưa biết reactror thật mà .Ucs ảo thì chỉ cần chọn o và chọn hướng X là được, mình k nghĩ bạn vẽ mặt bằng thì cần oxy bị lộn ngược lại (?) Em cần "UCS ảo" oxy lộn ngược là để dùng cho các m bằng rộng mà đối xứng qua 2 trục qua tâm của MB đó ==> em sẽ cố chế lệnh MIRROR thay copy :D ==> giảm 3/4 khối lượng & kiểm soát bản vẽ tốt hơn

- Topic 2 : viewport bên Model Space ?
Mà bạn vẽ chi khi mà cái mặt bằng chưa hòm hòm đã đi bổ rồi (để mà thực hiện cái thao tác xoay kia liên tục ?) Vâng em làm cả concept nên phải bổ Mặt Cắt chứ, cái MB em thấy đến tận khi thi công xong đi vô hoàn thiện nó mới stop
Hoặc cùng lắm cho tất cả các đối tượng bao gồm mặt bằng - mặt đứng - mặt bên vào 1 group, lúc cần thì xoay cả cụm, đảm bảo theo ý bạn . Cách làm này như em viết ở port 1 em đã làm rồi , bản vẽ mà có 20 tầng 1 loạt khoảng 4 thậm chí 7,8 măt cắt . Lại còn chi chít Text+ hach bác xoay liên tục cả đống đó thử xem nó có bay cả CAD ra ko cho save ko? Hơn nữa làm sao xoay đc khi MB Trần , MA Sàn , MB Điện , Nước của ng khác đang vẽ đang tham chiếu Xref tới MB mà em đang vẽ qua hệ thống máy chủ để cập nhật liên tục các thay đổi nếu có của MB Kiến Trúc ( cty em tách riêng các Layer của MĐứng Mặt Cắt ra , các đối tượng chỉ MB Kiế trúc thể hiện cũng đc tách riêng ra , các bộ môn khác tắt hết các Fiter Layer đó đi, khi in bind vô và xóa ,nên em xoay hay vẽ MĐứng Mặt Cắt bét nhè cũng ko anh hưởng đến ai ) . Mà đâu phải chỉ so sanh hình họa khi bắt đầu khởi tạo MCắt đâu , chỉnh sửa đến khi khánh thành công trình cơ mà

P/s : cả 2 cái này người viết lisp đều làm được, bạn mới chỉ sấn được tới phần ssget đã bỏ của chạy theo selectsimilar (cad đời cũ thì có ssx), sao không cố lên 1 chút nữa bạn ?


  • 0

#10 ketxu

ketxu

    Copier - Paster - Editor

  • Moderator
  • PipPipPipPipPipPipPip
  • 5679 Bài viết
Điểm đánh giá: 2605 (tuyệt vời)

Đã gửi 12 July 2012 - 12:21 PM

Nếu cảm nhận về chiều khó quá, phải xoay ra, thì mình nghĩ bạn nên dùng laptop, kiếm cái bàn phím usb, lúc nào cần nhìn ngang thì dựng lap lên, dễ cực :">
Mà khi tạo New view trong Cad bạn có thể tùy chỉnh góc nhìn current cơ mà nhỉ ? Tạo 2 cái view 1 ngang, 1 dọc, rồi đặt lệnh tắt cho nó có phải nhàn k ?

Hoặc bạn tự tạo lisp cho bạn : chọn tất cả các đối tượng quan tâm = ssget, lưu vào 1 biến ss. Dùng command gọi lệnh ucs, plan, zoom objects ss. Tất cả đều thuần command

Tóm lại là cả 2 cái bạn yêu cầu theo mình đều làm được. Rồi sẽ có bác giúp bạn ^^
  • 0

Thành viên nhóm CadMagic.
Mời bạn ghé thăm facebook nhóm - Page viết lisp theo yêu cầu  :
CAD MAGIC


#11 lp_hai

lp_hai

    biết lệnh measure

  • Members
  • PipPipPipPipPipPip
  • 456 Bài viết
Điểm đánh giá: 202 (khá)

Đã gửi 12 July 2012 - 02:20 PM

Theo em thì do bác NTD này ko diễn đạt đúng ý đồ thôi, em là một thợ vẽ nên thường dụng tới thằng này lắm, khi có một mặt bằng và muốn vẽ 4 mặt đứng xung quanh: thay vì phải copy ra một mặt bằng nữa rồi vẽ xong mặt đứng này lại phải quay cái mặt bằng vừa copy ra để vẽ tiếp cái khác===> vừa nặng máy vừa khó đối chiếu mặt đứng với MB
Vì vậy sữ dụng lệnh Plan để vẽ 4 mặt đứng nằm xung quanh cái MB. có lẽ đây là "View port bên Model" của bác ấy?!
Em xin góp một code để giảm phiền toái khi phải sữ dụng Plan nhiều. Lisp yêu cầu chọn đối tượng để zoom object và nhập vào góc quay. lệnh AS để thay đổi View, lệnh ASS để trở về Plan của UCS World

(defun c:AS(/ goc dtz)
(setq dtz (ssget)
goc (getreal "\nangle: "))
(command "ucs" "z" (* -1 goc) "")
(command "plan" "")
(command "zoom" "o" dtz "")
(princ)
)
(defun c:AsS()
(command "ucs" "")
(command "plan" "")
(princ)
)

  • 2
Hình đã gửi

#12 NTD

NTD

    biết lệnh rotate

  • Members
  • PipPipPip
  • 135 Bài viết
Điểm đánh giá: 11 (tàm tạm)

Đã gửi 12 July 2012 - 04:04 PM

Cảm ơn bác em chay đc rồi . Em muốn có thêm vài chế độ trong cùng 1 lệnh này như em đã viết ở port 1 thì thế nào . Mà thôi , bác cứ để em thử lần mò xem có tự làm đc ko đã , nếu khó quá mai bác giúp em nhá
  • 0

#13 NTD

NTD

    biết lệnh rotate

  • Members
  • PipPipPip
  • 135 Bài viết
Điểm đánh giá: 11 (tàm tạm)

Đã gửi 12 July 2012 - 04:24 PM

Các bác có cách nào làm nó ko regen bản vẽ ko ? Trừ khi bộ nhớ tràn nó tự động regen thì đành chịu chứ rengen thế này mà chỉnh sửa bản vẽ hòan công thì chết em . Cái này thì em thua ko biết tìm hiểu từ đâu

Command: AS
Select objects: 1 found

Select objects:
angle: 180 ucs
Current ucs name: *NO NAME*
Specify origin of UCS or [Face/NAmed/OBject/Previous/View/World/X/Y/Z/ZAxis]
<World>: z
Specify rotation angle about Z axis <90>: -180.0000000000000
Command: CV Unknown command "CV". Press F1 for help.

Command: plan
Enter an option [Current ucs/Ucs/World] <Current>: Regenerating model.
Regenerating model.

Command: zoom
Specify corner of window, enter a scale factor (nX or nXP), or
[All/Center/Dynamic/Extents/Previous/Scale/Window/Object] <real time>: o

Select objects: 1 found

Select objects:
Command:
  • 0

#14 lp_hai

lp_hai

    biết lệnh measure

  • Members
  • PipPipPipPipPipPip
  • 456 Bài viết
Điểm đánh giá: 202 (khá)

Đã gửi 12 July 2012 - 04:24 PM

Cảm ơn bác em chay đc rồi . Em muốn có thêm vài chế độ trong cùng 1 lệnh này như em đã viết ở port 1 thì thế nào . Mà thôi , bác cứ để em thử lần mò xem có tự làm đc ko đã , nếu khó quá mai bác giúp em nhá

Đọc kỹ lại yêu cầu của bạn NTD mình nghĩ chắc BV của bạn không dùng Xref ???
Tại sau bạn ko sữ dụng MB riêng một file, MC riêng...... khi cần tham chiếu qua lại thì chỉ việc xerf, muống xoay muống move thì tùy, File gốc nó vẫn nằm đó nếu bạn không sửa!

Còn cái vụ Zoom scale sau khi xoay hướng nhìn, theo mình thì có nhất thiết phải bằng scale trước đó không, khi mà bạn đang thao tác bên Model?
Mình cũng làm nhiều cái nói lớn thì không dám, nhưng cũng không phải là nhỏ. Chưa bao giờ phải sợ cái vụ Regen gì đó, bạn sợ có lẽ vì cách quản lý file chưa tốt? Tại sao bao nhiêu thứ phải nằm chung một chổ rồi than nặng nè! :)
  • 0
Hình đã gửi

#15 quickandfine

quickandfine

    biết lệnh copy

  • Members
  • PipPipPip
  • 110 Bài viết
Điểm đánh giá: 9 (bình thường)

Đã gửi 12 July 2012 - 04:39 PM

Theo em thì do bác NTD này ko diễn đạt đúng ý đồ thôi, em là một thợ vẽ nên thường dụng tới thằng này lắm, khi có một mặt bằng và muốn vẽ 4 mặt đứng xung quanh: thay vì phải copy ra một mặt bằng nữa rồi vẽ xong mặt đứng này lại phải quay cái mặt bằng vừa copy ra để vẽ tiếp cái khác===> vừa nặng máy vừa khó đối chiếu mặt đứng với MB
Vì vậy sữ dụng lệnh Plan để vẽ 4 mặt đứng nằm xung quanh cái MB. có lẽ đây là "View port bên Model" của bác ấy?!
Em xin góp một code để giảm phiền toái khi phải sữ dụng Plan nhiều. Lisp yêu cầu chọn đối tượng để zoom object và nhập vào góc quay. lệnh AS để thay đổi View, lệnh ASS để trở về Plan của UCS World


(defun c:AS(/ goc dtz)
(setq dtz (ssget)
goc (getreal "\nangle: "))
(command "ucs" "z" (* -1 goc) "")
(command "plan" "")
(command "zoom" "o" dtz "")
(princ)
)
(defun c:AsS()
(command "ucs" "")
(command "plan" "")
(princ)
)

Chào các bác.
Em chưa biết nhiều về Ucs hay Plan lắm, nhưng thi thoảng thấy mấy anh trong phòng xoay view port bằng lệnh UCS rồi Plan gì đó (em chưa nhìn kịp) thì thấy cũng hơi lâu, Em thử chạy đoạn lisp của bác lp_hai thì thấy nhanh hơn, nhưng có điều nếu góc xoay là lẻ thì mình làm thế nào? Liệu có thể chọn góc xoay bằng cách pick 2 điểm không ạ? Em xin cảm ơn ạ!
  • 1

#16 lp_hai

lp_hai

    biết lệnh measure

  • Members
  • PipPipPipPipPipPip
  • 456 Bài viết
Điểm đánh giá: 202 (khá)

Đã gửi 12 July 2012 - 05:19 PM

Chào các bác.
Em chưa biết nhiều về Ucs hay Plan lắm, nhưng thi thoảng thấy mấy anh trong phòng xoay view port bằng lệnh UCS rồi Plan gì đó (em chưa nhìn kịp) thì thấy cũng hơi lâu, Em thử chạy đoạn lisp của bác lp_hai thì thấy nhanh hơn, nhưng có điều nếu góc xoay là lẻ thì mình làm thế nào? Liệu có thể chọn góc xoay bằng cách pick 2 điểm không ạ? Em xin cảm ơn ạ!

Nếu bạn muốn dùng chuột chọn góc:


(defun c:AAS(/ goc dtz)
(setq dtz (ssget)
goc (getangle "\nangle: "))
(command "ucs" "z" (/(* -180 goc) pi)"")
(command "plan" "")
(command "zoom" "o" dtz "")
(princ)
)

  • 2
Hình đã gửi

#17 NTD

NTD

    biết lệnh rotate

  • Members
  • PipPipPip
  • 135 Bài viết
Điểm đánh giá: 11 (tàm tạm)

Đã gửi 12 July 2012 - 09:39 PM

Đọc kỹ lại yêu cầu của bạn NTD mình nghĩ chắc BV của bạn không dùng Xref ???
Ở Cty em nếu em đc giao đầu việc là vẽ kỹ thuật riêng MB Trần hay MB Sàn của 1 tòa tháp thì em gần như chắc chắn sẽ ko phải vẽ MĐứng MCắt . Nên em sẽ tham chiếu Xref Files MB Kiến Trúc , nhưng trong File Xref đó sẽ có cả MĐứng MCắt ==> em tắt , đóng băng , ko in toàn bộ các Layer nào nằm trong Fiter Layer của MĐứng MCắt ==>người khác ko đc xoay MB Kiến Trúc ==> Xoay MĐứng MCắt . MB Sàn thì chỉ thế ,nhưng MB Trần còn Xref MB các bộ môn: Điện , ĐHòaThGió, BMS, PCCCháy, , MB Dầm Sàn Kết Cấu
Tại sau bạn ko sữ dụng MB riêng một file, MC riêng...... khi cần tham chiếu qua lại thì chỉ việc xerf, muống xoay muống move thì tùy, File gốc nó vẫn nằm đó nếu bạn không sửa!
Trước kia cty em cũng đã từng chia ra 3 phe với cách quan điểm quản lý Files khác nhau.
Phe 1 làm như bác nói xem ra ko khả thi vì :
- MB ko có chuyện stop hẳn mới vẽ MĐ MC , chuyện MB thay đổi phụ thuộc chủ đầu tư, kinh phí dự toán, tiêu chuẩn công trình , kỹ thuật Kêt cấu , thậm chí ngay đến cả ông PCCCháy trên sở ko đồng ý ko ký bvẽ thì MB cũng phải thay đổi theo . Chuyện có 1 KTS ( :D hí hí ) làm xong MB concept 1 cái tòa tháp mà có thể vượt qua mọi yếu tố mọi cái đầu của các ông trên để ko thay đổi MB thì thật sự trên thế giới chưa có ông KTS nào như vậy . Như vậy là phe này chạy ra chạy vô mấy cái Xref & Block liên tục :D vì ko thể vẽ cái nào dứt điểm ngay đc
- Phe này làm tăng gấp 2 thậm chí gấp 4 gấp 5 lần số File gửi các bộ môn khác và đặc biệt là gửi cái ông giám đốc kỹ thuật (KTS) . Bác mà là ông đó bác có tẩu hỏa nhập ma & phát cáu ko nếu cùng lúc phải quản lý ít nhất 5 tòa tháp 1 lúc , mà là quản lý tất cả các bộ môn . Ông này ko vẽ mà chỉ soi , nên MB MĐ MC tách ra là ông này dễ đi tù nhất :D
- Phe này lỗi kỹ thuật về hình họa nhiều nhất , thể hiện hồ sơ với Font Text , Hieght Text lung tung nhất , Thậm chí MB vẽ & ghi sử dụng thường có chuyện ko liên quan đến vật liệu MĐ MC
Được cái phe này ko sợ regen :D khi vẽ MĐ MC mà ko sử dụng MB là file Xref ==> hay vẽ sai . Còn nếu Xref MB vô thì phe này sợ regen nhất cty :D vì cứ chạy ra lại chạy vô Xref

Phe thứ 2 làm như cách 2 mà em đã yêu cầu ở post 1
- 1 Files duy nhất gửi các bộ môn & nhất là cái ông kia , bác đừng bảo em sao ko theo phe 1 rồi tổng hợp thành 1 File mà gửi ông ý , cty em có hệ thống máy chủ , hàng ngày ông ý mở bản vẽ em đang vẽ ra kiểm tra nhiều lần ko vào 1 thòi điểm nhất định nào . Ông này mà ốm nghỉ 1 tuần thì sẽ phải thức đêm 1 tuần tiếp theo để phát hiện sai sót trong hàng trăm Files :D . Xem ra ông này mới đủ sức khỏe để đc gọi là KTS :D
- Sai sót it hơn phe 1
- Luôn sợ regen nếu nhận đầu việc vẽ cả MB MĐ MC

Phe thứ 3 sao cũng đc lúc thế này lúc thế khác , thậm chí còn sáng tạo nhiều kiểu mới lạ hơn :D mà công nhận là phe này sáng tạo thật :D , nhiều kiểu lắm bác ạ

Giám đóc kỹ thuật họp toàn cty bảo : tất cả làm theo phe 2 , tao ốm rồi :D

Còn cái vụ Zoom scale sau khi xoay hướng nhìn, theo mình thì có nhất thiết phải bằng scale trước đó không, khi mà bạn đang thao tác bên Model?
Đúng là em chỉ làm bên Model thôi . Em cần cái này, cần view scale ko thay đổi bởi vì em hay chia của sổ viewport ra làm 2 : MB cái bên trái MC cái bên phải đã xoay view . Khi kết hợp với tính năng SyncViewport - Relative Sync trong ứng dụng của bác Detailing bên topic này http://www.cadviet.c...ic=65117&st=120 bác sẽ hiểu em hơn , bác phải đc kỹ cai topic kia cơ chứ em lại giải thích thì dài lắm :D
(Em ko thích chia kiểu trên dưới vì chiều cao 2 cái nhỏ quá màn wire mà , quan sát hạn chế ==> dễ bổ sót nhưng sai sót trên bản vẽ hơn ) .
Nếu bác co time thì giúp em có các chế độ như em viết trong post 1 , em thử mày mò mà thấy khó quá , đọc lại ssget của bác ket xu & xem các lisp mình có mà chưa nhìn ra hướng giải quyết
Mình cũng làm nhiều cái nói lớn thì không dám, nhưng cũng không phải là nhỏ. Chưa bao giờ phải sợ cái vụ Regen gì đó, bạn sợ có lẽ vì cách quản lý file chưa tốt? Tại sao bao nhiêu thứ phải nằm chung một chổ rồi than nặng nè! :)
Em đẫ cố gắng giải thích cạn kẽ lắm rồi mong nhất bác làm đc chỗ này , 1 đoạn mã chống regen sẽ giúp đc bao ng đưa đoạn mã đó vào các Lisp khác nhau . 1 việc mà làm ví rất nhiêu ng


Em biết trước là khi đưa ra topic này thì sẽ lại nẩy ra 1 cuộc tranh luận về quan điểm nên theo phe nào trong 3 phe như kiểu cty em ngày trước . Em đã cố gắng giải thích ở post 1 tại sao em phải làm theo phe 2 mà ko phải phe 1 . Viết dài dòng khiến các bác đọc nhiều đâm bực ==> bảo em theo ....phe 1 . Nhưng mong các bác hiểu cho : mỗi cây mỗi hoa mỗi nhà mỗi cảnh . Em yêu cầu các tùy chọn hơi nhiều trong Lisp là nhằm củng cố & khác phục các thiếu sót trong cách làm thư 2 vì em là ng cầm đầu bên phe thứ 2 ở cty . Sắp có 1 cuộc thay đổi ban lãnh đạo & cất nhắc 1 số nhân viên lên trưởng phòng . Em là 1 trong các ứng cử viên của cái ghế đó , đối thủ chính của em lại là thằng cầm đầu phe 1 hồi xưa , chỉ có xét chọn bằng năng lực thôi . Nếu em ko giữ đc vị thế tức là ko đưa ra đc cách giải quyêt 1 danh sách các thiếu sót dở hơi trong phương pháp làm việc trong đó có vấn đề của topic này thì có nghĩa là em lại chỉ là nhóm trưởng mà thôi
Mong các bác hiểu cho , mưu hèn kế bẩn chắc là cái cuối cùng em phải sử dụng đến nếu cần phải như vậy :D
  • 0

#18 Detailing

Detailing

    biết lệnh imageclip

  • Members
  • PipPipPipPipPipPipPip
  • 667 Bài viết
Điểm đánh giá: 278 (khá)

Đã gửi 13 July 2012 - 01:03 AM

Công ty bác làm toàn job lớn thế thì dùng Revit đi. có các lợi thế sau chỉ nói về những thứ bác cần trong topic này thôi
  • Tất cả các bộ môn làm chung trên 1 file central
  • ko cần vẽ mấy cái MĐ hay MC (cần drafting lại)
  • ko cần quan tâm sửa MB thì cần sửa chỗ nào - nó sửa hết
  • vật liệu (text) nó tự cập nhật bảo đảm chính xác cho tất cả
Bác đề xuất Revit + 1 bài thuyết trình ứng dụng BIM trong thiết kế dám chừng lên luôn chức của ông GĐKT ko chừng chứ đừng nói trưởng phòng :D
Good luck!
  • 0

Ideas don't matter, execution does!

1908412_308002392716743_8165279281236341


#19 NTD

NTD

    biết lệnh rotate

  • Members
  • PipPipPip
  • 135 Bài viết
Điểm đánh giá: 11 (tàm tạm)

Đã gửi 13 July 2012 - 01:27 AM

Em đề xuất điều đó từ lâu rồi bác ơi ==> suýt nữa thì đc tập thể bầu cho em làm nhóm trưởng 1 nhóm.. mình em luôn :D Đề xuất phát nữa chắc em đc cho làm trưởng phòng "bảo vệ" vì hay "bảo vệ" quan điểm quá :D
Ngay đến bản thân em mới chỉ là lý thuyết revit thôi đã đưa dự án nào vô thực tế = revit đâu
Nhưng 1 loạt các topic em sắp post tới đây sẽ phần nào revit hóa đc AutoCAD cơ bản mà cty vần dùng , mong chờ tất cả vào sự nhiệt tình và thông minh của các bác cả đấy :rolleyes:
  • 0

#20 lp_hai

lp_hai

    biết lệnh measure

  • Members
  • PipPipPipPipPipPip
  • 456 Bài viết
Điểm đánh giá: 202 (khá)

Đã gửi 13 July 2012 - 08:43 AM

haizzzzz
Bạn thử nghĩ làm cách 2: MB MĐ MC chung một file, khi sửa BV cần nhiều người sửa thì làm sao???? Có thấy bất tiện ko?
Cách 1 là OK nhất, tuy nhiên có lẽ cái ông cầm đầu của nhóm này chắc luyện Xref chưa đến nơi đến chốn nên mới bị tùm lum như vậy.
Mình gợi ý cho cách 1 thế này nhé:
Đầu tiên muốn làm Xref phải chia file theo làm 2 nhóm:
1) Nhóm Base (bao gồm những file gốc: Khung tên, MB, Mđ, MC, chi tiết.....) là những file riêng lẻ, chỉ có hình vẽ
2) Nhóm Sheet (gồm những file Trình bày hoàn chỉnh) bạn trình bày ra BV ở đây. Khi cần trình bày nội dung trong BV này gồm những thằng nào thì gọi Xref từ nhóm Base ra, không cần phải tuốt tuồn tuột tất cả các thằng vào một file

Nói như bạn thì MB có chỉnh sửa thì MC cũng chỉnh sửa được chứ có sao? Thậm chí làm theo cách 1, khi bạn đang sửa MB bạn có thể nhờ một người khác sửa MĐ cùng lúc, Trong file MĐ bạn có tham chiếu Xref MB vào, vậy nên khi bạn sửa MB thì tự động cái Xref MB bên file MĐ cũng cập nhật theo.....

Còn về cái ông soi mói gì đó! ổng muốn xem tất cả trên cùng một file để dễ dàng tìm sâu trong... rừng lá? Xin cứ tự nhiên, Cứ Xref tất cả vào một chổ mà xem cho đã....
Lưu ý: file Base phải chú ý vị trí chính xác khi vẽ, để khi xref vào những file khác nó nằm vị trí đúng như mong muốn mà ko bị nhảy lung tung.
  • 0
Hình đã gửi